package org.bitbucket.bradleysmithllc.etlunit.feature;

import org.bitbucket.bradleysmithllc.etlunit.ClassDirector;
import org.bitbucket.bradleysmithllc.etlunit.PatternClassDirector;
import org.bitbucket.bradleysmithllc.etlunit.regexp.TestExpression;

public class PatternedClassDirectorFeature extends AbstractFeature
{
	private final String instanceName;

	private final PatternClassDirector patternClassDirector;

	public PatternedClassDirectorFeature(String instanceName, TestExpression tex)
	{
		patternClassDirector = new PatternClassDirector(tex);

		this.instanceName = instanceName;
	}

	@Override
	public String getFeatureName()
	{
		return "pattern-class-director_" + instanceName;
	}

	@Override
	public ClassDirector getDirector()
	{
		return patternClassDirector;
	}

	@Override
	public long getPriorityLevel()
	{
		return -1L;
	}
}
