package org.bitbucket.bradleysmithllc.etlunit.parser;

public class ETLTestOperandImpl extends ETLTestDebugTraceableImpl implements ETLTestOperand
{
	private final ETLTestValueObject value;

	private final ETLTestOperation operation;

	public ETLTestOperandImpl(ETLTestOperation pOperation, ETLTestValueObject op)
	{
		operation = pOperation;
		value = op;
	}

	public ETLTestOperandImpl(ETLTestOperation pOperation, ETLTestValueObject op, Token t)
	{
		super(t);
		operation = pOperation;
		value = op;
	}

	@Override
	public ETLTestValueObject getValue()
	{
		return value;
	}

	@Override
	public String getOperandAsString()
	{
		return value.getValueAsString();
	}

	@Override
	public ETLTestOperation getOperation()
	{
		return operation;
	}
}